<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE mapper PUBLIC '-//mybatis.org//DTD Mapper 3.0//EN'
  'http://mybatis.org/dtd/mybatis-3-mapper.dtd'>

<mapper namespace='com.example.mybatis.mappers.PostMapper'>

	<resultMap type='Post' id='PostResult'>
		<id property='postId' jdbcType="INTEGER" column='post_id' />
		<result property='title' jdbcType="VARCHAR" column='title' />
		<result property='content' column='content' />
		<result property='createdOn' column='created_on' />
		<result property='blogId' column='blog_id' />
	</resultMap>

	<resultMap type='Comment' id='CommentResult'>
		<id property='commentId' jdbcType="INTEGER" column='comment_id' />
		<result property='title' jdbcType="VARCHAR" column='title' />
	</resultMap>

	<resultMap type='CommentPost' id='CommentPostResult'>
		<id property='commentId' jdbcType="INTEGER" column='comment_id' />
		<id property='postId' jdbcType="INTEGER" column='post_id' />
	</resultMap>

	<insert id='insertPost' parameterType='Post' useGeneratedKeys='true'
		keyProperty='postId'>

		INSERT INTO POST(title, content, created_on,
		blog_id)
		VALUES(#{title}, #{content}, #{createdOn},
		#{blogId})

	</insert>

	<insert id='insertComment' parameterType='Comment'
		useGeneratedKeys='true' keyProperty='commentId'>

		INSERT INTO comment(
		title)
		VALUES(#{title})

	</insert>

	<insert id='insertCommentPost' parameterType='CommentPost'
		useGeneratedKeys='true' keyProperty='commentId'>

		INSERT INTO
		post_comment(comment_id,
		post_id)
		VALUES(#{commentId}, #{postId})

	</insert>


	<select id='getPostById' parameterType='int' resultMap='PostResult'>

		SELECT
		p.post_id as post_post_id,
		p.title as post_title, p.content as
		post_content,
		p.created_on as post_created_on,
		p.blog_id as post_blog_id
		FROM post p
		WHERE p.post_id=#{postId}
	</select>

	<select id='getPostsByBlogId' parameterType='int' resultMap='PostResult'>

		SELECT
		*
		FROM post
		WHERE blog_id=#{blogId}
	</select>

	<select id='getAllPosts' resultMap='PostResult'>
		SELECT
		p.post_id as
		post_post_id,
		p.title as post_title, p.content as post_content,
		p.created_on as post_created_on,
		p.blog_id as post_blog_id
		FROM post p
	</select>

</mapper>